#include "Collisionbox.h"

//  ab Ɠ_ c ́Aab ɂŋߐړ_ d ߂
// d(t) = a + t*(a - b) ̃p[^ t Zo
void ClosestPtPointSegment(fk_Vector c, fk_Vector a, fk_Vector b, double &t, fk_Vector &d)
{
	fk_Vector ab = b - a;

	t = (c - a)*ab;
	if(t < FK_EPS) {
		t = 0.0;
		d = a;
	} else {
		double denom = ab*ab;
		if(t > denom) {
			t = 1.0;
			d = b;
		} else {
			t /= denom;
			d = a * t*ab;
		}
	}
}

// _ c Ɛ ab ̊Ԃ̋̕߂
double SqDistPointSegment(fk_Vector a, fk_Vector b, fk_Vector c)
{
	fk_Vector ab = b - a, ac = c - a, bc = c - b;
	double e = ac*ab;
	if(e < FK_EPS) return ac*ac;
	double f = ab*ab;
	if(e >= f) return bc*bc;
	return ac*ac - e*e/f;
}

// n  min ȏ max ȉɂ܂߂
double Clamp(double n, double min, double max)
{
	if(n < min) return min;
	if(n > max) return max;
	return n;
}

//  P1Q1  P2Q2 ɂŋߐړ_ C1  C2 ߂
// P1Q1  C1 ̈ʒu s ƁAP2Q2  C2 ̈ʒu t Ԃ
// Ԃl C1  C2 ̋̕ƂȂ
double ClosestPtSegmentSegment(fk_Vector p1, fk_Vector q1, fk_Vector p2, fk_Vector q2,
							   double &s, double &t, fk_Vector &c1, fk_Vector &c2)
{
	fk_Vector d1 = q1 - p1;
	fk_Vector d2 = q2 - p2;
	fk_Vector r = p1 - p2;
	double a = d1*d1;
	double e = d2*d2;
	double f = d2*r;
	if(a < FK_EPS && e < FK_EPS) {
		s = t = 0.0;
		c1 = p1;
		c2 = p2;
	}
	if(a < FK_EPS) {
		s = 0.0;
		t = f/e;
		t = Clamp(t, 0.0, 1.0);
	} else {
		double c = d1*r;
		if(e < FK_EPS) {
			t = 0.0;
			s = Clamp(-c/a, 0.0, 1.0);
		} else {
			double b = d1*d2;
			double denom = a*e - b*b;
			if(denom != 0.0) {
				s = Clamp((b*f - c*e)/denom, 0.0, 1.0);
			} else {
				s = 0.0;
			}
			t = (b*s + f)/e;
			if(t < 0.0) {
				t = 0.0;
				s = Clamp(-c/a, 0.0, 1.0);
			} else if(t > 1.0) {
				t = 1.0;
				s = Clamp((b - c)/a, 0.0, 1.0);
			}
		}
	}
	c1 = p1 + d1*s;
	c2 = p2 + d2*t;
	return (c1 - c2)*(c1 - c2);
}


CollisionBox::CollisionBox(void)
{
	model.setShape(&block);

	return;
}

CollisionBox::~CollisionBox(void)
{
}

void CollisionBox::setSize(double argX, double argY, double argZ)
{
	size.x = argX/2.0;
	size.y = argY/2.0;
	size.z = argZ/2.0;
	block.setSize(argX, argY, argZ);
	setPos(pos);

	return;
}

void CollisionBox::setPos(fk_Vector argPos)
{
	pos = argPos;
	model.glMoveTo(pos.x, pos.y+size.y, pos.z);

	return;
}

double CollisionBox::getLenAABBToPoint(fk_Vector p)
{
	double retVal = 0.0;

	// eœ_ŏlȉ͍őlȏȂ΁Al
	if( p.x < -size.x ) retVal += ( p.x + size.x ) * ( p.x + size.x );
	if( p.x >  size.x ) retVal += ( p.x - size.x ) * ( p.x - size.x );

	if( p.y < -size.y ) retVal += ( p.y + size.y ) * ( p.y + size.y );
	if( p.y >  size.y ) retVal += ( p.y - size.y ) * ( p.y - size.y );

	if( p.z < -size.z ) retVal += ( p.z + size.z ) * ( p.z + size.z );
	if( p.z >  size.z ) retVal += ( p.z - size.z ) * ( p.z - size.z );

	return sqrt(retVal);
}

double CollisionBox::getNormAABBToLine(fk_Vector p, fk_Vector q, fk_Vector *n)
{
	static fk_Vector retVec;
	retVec.init();
	n->init();

	// e̔䗦߂
	if( p.x >  size.x && q.x <  size.x ) {
		retVec.x = (p.x - size.x)/(p.x - q.x);
		n->x =  size.x - q.x;	// n->x =  1.0;
	}
	if( p.x < -size.x && q.x > -size.x ) {
		retVec.x = (p.x + size.x)/(p.x - q.x);
		n->x = -size.x - q.x;	// n->x = -1.0;
	}
	if( p.y >  size.y && q.y <  size.y ) {
		retVec.y = (p.y - size.y)/(p.y - q.y);
		n->y =  size.y - q.y;	// n->y =  1.0;
	}
	if( p.y < -size.y && q.y > -size.y ) {
		retVec.y = (p.y + size.y)/(p.y - q.y);
		n->y = -size.y - q.y;	// n->y = -1.0;
	}
	if( p.z >  size.z && q.z <  size.z ) {
		retVec.z = (p.z - size.z)/(p.z - q.z);
		n->z =  size.z - q.z;	// n->z =  1.0;
	}
	if( p.z < -size.z && q.z > -size.z ) {
		retVec.z = (p.z + size.z)/(p.z - q.z);
		n->z = -size.z - q.z;	// n->z = -1.0;
	}
	if(!n->isZero()) {
		*n *= model.getMatrix();
		*n -= model.getPosition();
	}

	return max(retVec.x, max(retVec.y, retVec.z));
}

fk_Vector CollisionBox::detectCollision(fk_Vector argPos, fk_Vector argVel)
{
	static fk_Vector tmpVec, retVec;
	static fk_Matrix tmpMat;
	static double dt, velDist;
	static bool bHit;

	tmpMat = model.getMatrix();
	tmpMat.inverse();
	tmpVec.init();
	retVec.init();
	velDist = argVel.dist();

	bHit = false;
	dt = 0.1;
	while(dt < 1.0+FK_EPS) {
		if(getLenAABBToPoint(tmpMat*(argPos+argVel*dt)) < FK_EPS) {
			bHit = true;
			break;
		}
		dt += 0.1;
	}
	if(!bHit) return tmpVec;

	dt = getNormAABBToLine(tmpMat*argPos, tmpMat*(argPos+argVel), &tmpVec);

	return tmpVec*1.1;
}
